from Node import Node
import logging
import Utility
import hashlib
import Config
import random
from ecdsa import SigningKey,SECP256k1
from ecdsa.keys import BadSignatureError

genesisBlock = ("I am the first block")
#
# class Role:
#     def __init__(self):
#         self.role =

class OverlayNode(Node):
    def __init__(self,id,network,weight):
        Node.__init__(self,id,network,weight)


        self.blockchain = [genesisBlock]
        self.currentRound = 1  # round is equivalent ot block height
        self.step = 0
        self.currentRoleCount = 20
        self.currentRole = "BLOCK_PROPOSER"
        self.currentSeed = None

        self.startNodeLifeCycleGenerator = self.startNodeLifeCycle()
        # adding initial task of bootstraping node.and it only contains ba* resume tasks
        # self.ResumeTasks.append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.ResumeTasks['1'].append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.commands.update({})



    # def processMessage(self,time,payload):
    #     super(OverlayNode, self).processMessage(time,payload)
    #     print("from overlay node : "+str(payload))
    def algo_processMsg(self,msg,tou):
        pk = msg[1][0]
        sign = msg[1][2]
        payload = msg[1][1]

        try:
            pk.verify(sign,bytes(str(payload).encode('UTF8')) )
        except BadSignatureError as badSign:
            print("bad signature")
            return 0,None,None

        round, step, sorthash, proof, previousblockHash, value = payload

        if previousblockHash != hashlib.sha256(self.blockchain[-1].encode('utf-8')).hexdigest() :
            print("not in the right chain")
            return 0, None, None


        seed = self.currentSeed
        role= (Config.ROLE_COMMITEE_FOR_VOTE, round, step)
        # Todo something is wrong here not getting correct votes back
        votes = Utility.verifySort(pk, sorthash, proof, seed, tou, role, self.network.pk_weight_map.get(pk), self.network.badaW)
        print("why votes be zero")
        print(votes,"\t",value,"\t",sorthash)
        return votes,value,sorthash
        pass

    def partOfCountVotes(self,round,step,start,counts,voters,T,tou):
        msgs = self.uniqueReceivedMessages.pop(Config.COMMITTEE_VOTE_MSG_type)
        for msg in msgs:

            msg_round = msg[1][1][0]
            msg_step = msg[1][1][1]
            payload = msg[1][1]
            msg_pk = msg[1][0]
            # print(round, " # ",step )
            if  msg_round== round and msg_step==step : #check if message belong to current round and current step or not
                votes,value,sorthash = self.algo_processMsg(msg,tou)
                if msg_pk in voters  or votes == 0:
                    print(self.id + " continuing")
                    continue
                voters.append(msg_pk)
                counts[value] = counts[value]+ votes
                if counts[value] > T*tou :
                    print("returning value")
                    return value

                pass
            else:
                self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type].append(msg)
            pass
        pass
    def startNodeLifeCycle(self):
        '''THis is monolithic algorand algorithm for a NOde'''
        self.logger.info("Life cycle started")

        while True:
            #increment round number


            blockForBA = None
            # Checking if I am a Block Propser
            previousHash = hashlib.sha256(self.blockchain[-1].encode('utf-8')).hexdigest()
            seed = ( previousHash,self.currentRound,0)
            self.currentSeed= (previousHash, self.currentRound, 0)
            hash, proof, j = Utility.sortition(self.sk,seed,Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, self.weight, self.network.badaW, self.pk)


            if j > 0 : # only the block proposer commity mebers can enter here
                self.logger.info("selection for BLOCK PROPOSAL with  J ="+str( j))
                min_sha_priority = None
                # min_sub_user_index = None
                # msg_to_broadcast = ( currentRound, hash , min_sub_user_index , min_sha_priority )
                for sub_user_index in range(self.weight):
                    input_to_SHA256 = (hash , sub_user_index,)
                    sha256_hash = hashlib.sha256((str(input_to_SHA256)).encode('utf-8')).hexdigest()
                    if not min_sha_priority :
                        min_sha_priority = sha256_hash
                        min_sub_user_index = sub_user_index
                    if sha256_hash < min_sha_priority:
                        min_sha_priority =  sha256_hash
                        min_sub_user_index = sub_user_index


                priority_msg_to_broadcast = ( Config.PRIORITY_MSG_type,self.currentRound, hash , min_sub_user_index , min_sha_priority,proof )
                self.logger.info("broadcsting priority message : "+str(priority_msg_to_broadcast))
                self.broadcast(self.network.time, priority_msg_to_broadcast)


                self.logger.info("WAITING FOR PRIORITY MESSAGES from others")
                yield "resume",Config.lambda_proposer

                greater_flag = True

                msgs = self.uniqueReceivedMessages.pop(Config.PRIORITY_MSG_type)
                for priority_msg_other in msgs :
                    if min_sha_priority > priority_msg_other[4]:
                        greater_flag = False

                if greater_flag :
                    self.logger.info("I am the block proposer")
                    '''
                    BLOCK_PROPOSAL_MSG_to_broadcast : ("BLOCK_PROPOSAL_MSG", previousblockhash,A random string as txns,Nod`s priority payload)
                    '''
                    BLOCK_PROPOSAL_MSG_to_broadcast = (Config.BLOCK_PROPOSAL_MSG_type, previousHash,Utility.pseudoRandomGenerator(random.randint(0,1000)),priority_msg_to_broadcast[1:])
                    self.logger.info("broadcsting BLOCK Proposal Message : " + str(BLOCK_PROPOSAL_MSG_to_broadcast))
                    self.broadcast(self.network.time, BLOCK_PROPOSAL_MSG_to_broadcast)
                    blockForBA = (previousHash,BLOCK_PROPOSAL_MSG_to_broadcast[2])
                else:  # others than block proposers
                    # everybody except highest priority block proposer is waiting for lambda_proposer+ lambda_block 33 seconds
                    yield "resume", Config.lambda_proposer + Config.lambda_block

            else: # others than block proposers
                # everybody is waiting for lambda_proposer+ lambda_block 33 seconds
                yield "resume", Config.lambda_proposer+Config.lambda_block

            # TODO:done : drop any priority messages in queue
            try :
                self.uniqueReceivedMessages.pop(Config.PRIORITY_MSG_type)
            except Exception:
                pass

            ######### Performing selection of block BA* ############################
            if not (self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type] or blockForBA) :
                blockForBA = (previousHash,"Empty")
            elif not blockForBA :
                # Todo select block from highest priority node
                blockForBA = (self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][1],
                              self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][2])
                pk = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][4]
                hash = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][1]
                proof = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][4]
                w = self.network.pk_weight_map.get(pk)
                seed = (previousHash, self.currentRound, 0)
                # TODO verify block proposal

                j = Utility.verifySort(pk, hash, proof, seed, Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, w, self.network.badaW)
                if j :
                    self.logger.info("it is a valid block proposed message with j : "+str(j))

            #todo : DONE : drop block proposal msges
            try :
                self.uniqueReceivedMessages.pop(Config.BLOCK_PROPOSAL_MSG_type)
            except Exception  as e:
                self.logger.error(e)

            # print(blockForBA)
            hashof_blockForBA = Utility.pseudoRandomGenerator(blockForBA)
            ######### END : Performing selection of block BA* ############################




            '''     START : REDUCTION ALGORITHM       '''

            '''    COmmitte vote reduction step 1'''
            reduct_step_1 = 1
            reduct_seed = (previousHash, self.currentRound, reduct_step_1)
            reduct_role_1 = (Config.ROLE_COMMITEE_FOR_VOTE,self.currentRound,reduct_step_1)
            reduct_sorthash, reduct_proof, reduct_j = Utility.sortition(self.sk, reduct_seed, Config.tou_step, reduct_role_1,
                                               self.weight, self.network.badaW, self.pk)
            # print("Reduction algo " + self.id," : ",reduct_j)

            if reduct_j > 0:
                self.logger.info("selection for VOTING COMMITEE with  J =" + str(reduct_j))
                payload = (self.currentRound,reduct_step_1,reduct_sorthash,reduct_proof,previousHash,hashof_blockForBA)
                committeeVoteMsg = (Config.COMMITTEE_VOTE_MSG_type,(self.pk,payload,self.sk.sign(bytes(str(payload).encode('UTF8')))))
                self.broadcast(self.network.time,committeeVoteMsg)
                self.logger.info("Broadcasting commitee messgae"+str(committeeVoteMsg))

            # print(self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type])
            yield "resume",Config.lambda_block+Config.lambda_step

            ######## count votes for hblock1 ###########
            countVote_round = self.currentRound
            countVote_reduct_step_1 = 1
            # Config.T
            # Config.tou_step
            countVote_lmbda = Config.lambda_block+Config.lambda_step


            start = int(self.network.time)
            counts = {}
            voters = []
            hblock1 = None
            while True:
                if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type] :
                    if int(self.network.time) > start + countVote_lmbda:
                        print(self.id + "Timing out")
                        hblock1 = Config.TIMEOUT
                        break
                    pass
                else:
                    temp_return = self.partOfCountVotes(countVote_round,countVote_reduct_step_1,start,counts,voters,Config.T,Config.tou_step)
                    print("temp_retiurn " ,temp_return)
                    if temp_return :
                        hblock1 = temp_return
                        break
                yield "resume",1 # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
            self.logger.info("returning from first count values with return value : "+str(hblock1))
            print("returning from first count values with return value",hblock1)

            ######## END : count votes for hblock1 ###########

            '''    END : COmmitte vote reduction step 1'''

            ''' Start : COmmitte vote reduction step 2 '''
            empty_hash = Utility.pseudoRandomGenerator((previousHash, "Empty"))

            # which block to vote empty or hblock1
            reduct_step2_block_to_vote = None
            if hblock1 == Config.TIMEOUT :
                reduct_step2_block_to_vote = empty_hash
                pass
            else:
                reduct_step2_block_to_vote = hblock1
                pass

            '''    COmmitte vote reduction step2 : reduct_step2_block_to_vote'''

            variables_reduct_step_2 = {}

            variables_reduct_step_2['step'] = 2
            variables_reduct_step_2['seed'] = (previousHash, self.currentRound, variables_reduct_step_2['step'])
            variables_reduct_step_2['role'] = (
            Config.ROLE_COMMITEE_FOR_VOTE, self.currentRound, variables_reduct_step_2['step'])
            variables_reduct_step_2['sorthash'], variables_reduct_step_2['proof'], variables_reduct_step_2[
                'j'] = Utility.sortition(self.sk, variables_reduct_step_2['seed'],
                                         Config.tou_step,
                                         variables_reduct_step_2['role'],
                                         self.weight, self.network.badaW,
                                         self.pk)
            # print("Reduction algo " + self.id," : ",reduct_j)

            if variables_reduct_step_2['j'] > 0:
                self.logger.info("selection for VOTING COMMITEE with  J =" + str(variables_reduct_step_2['j']))
                variables_reduct_step_2['payload'] = (
                    self.currentRound, variables_reduct_step_2['step'], variables_reduct_step_2['sorthash'],
                    variables_reduct_step_2['proof'], previousHash, reduct_step2_block_to_vote)
                variables_reduct_step_2['committeeVoteMsg'] = (Config.COMMITTEE_VOTE_MSG_type,
                                                               (self.pk, variables_reduct_step_2['payload'],
                                                                self.sk.sign(bytes(
                                                                    str(variables_reduct_step_2['payload']).encode(
                                                                        'UTF8')))))
                self.broadcast(self.network.time, variables_reduct_step_2['committeeVoteMsg'])
                self.logger.info("Broadcasting commitee messgae" + str(variables_reduct_step_2['committeeVoteMsg']))

            # yield "resume", Config.lambda_block + Config.lambda_step

            '''    COmmitte vote reduction step2 : reduct_step2_block_to_vote'''

            ######## count votes for hblock1 ###########
            CountVotes_step2 = {}
            CountVotes_step2['countVote_round'] = self.currentRound
            CountVotes_step2['countVote_step'] = 1
            # Config.T
            # Config.tou_step
            CountVotes_step2['countVote_lmbda'] = Config.lambda_block + Config.lambda_step

            CountVotes_step2['start'] = int(self.network.time)
            CountVotes_step2['counts'] = {}
            CountVotes_step2['voters'] = []
            CountVotes_step2['hblock2'] = None
            while True:
                if not self.uniqueReceivedMessages[Config.COMMITTEE_VOTE_MSG_type]:
                    if int(self.network.time) > CountVotes_step2['start'] + CountVotes_step2[
                        'countVote_lmbda']:
                        print(self.id + "Timing out")
                        CountVotes_step2['hblock2'] = Config.TIMEOUT
                        break
                    pass
                else:
                    CountVotes_step2['temp_return'] = self.partOfCountVotes(
                        CountVotes_step2['countVote_round'], CountVotes_step2['countVote_step'],
                        CountVotes_step2['start'], CountVotes_step2['counts'],
                        CountVotes_step2['voters'], Config.T, Config.tou_step)
                    print("CountVotes_step2",CountVotes_step2['temp_return'])
                    if CountVotes_step2['temp_return']:
                        CountVotes_step2['hblock2'] = CountVotes_step2['temp_return']
                        break
                yield "resume", 1  # this is to allow other nodes to be simulated and not get this node into infinite waiting on single node
            self.logger.info(
                "returning from first count values with return value : " + str(CountVotes_step2['hblock2']))
            print("CountVotes_step2",CountVotes_step2['hblock2'])

            ######## END : count votes for hblock1 ###########

            var_BBA_star = {}

            if CountVotes_step2['hblock2'] == Config.TIMEOUT:
                var_BBA_star['block_hash']= empty_hash
            else:
                var_BBA_star['block_hash'] = CountVotes_step2['hblock2']


            print("I am culprit " ,var_BBA_star['hblock2'])
            ''' END : COmmitte vote reduction step 2 '''

            yield "resume", 9
            # self.logger.info(self.uniqueReceivedMessages)
            yield "resume",40000
            '''     END : REDUCTION ALGORITHM       '''
            '''
             TODo check if node is selected as BLOCK_PROPOSER
                if yes 
                then
                    select highest priority subuser and gossip the message
                    wait for lambda_proposer=3 sec and hear other block propositions
                    take decision based on received propositions and determine if himself is a highest priority or not
                    if yes
                        broacast the block proposal <format of block proposal>
                
                everybody except highest priority block proposer waits for  t_proposer+t_block time to here the proposed block
                    if received proposal
                    then 
                        start BA* with this new block
                        validate sortition of proposed block
                        if yes
                        then
                            start reduction
                        else 
                            vote for empty block
                    else 
                        start BA* with empty block
                
                
                        
                        
            '''


            pass

        pass



















def m(v):
    v.append('ganesh')

if __name__ == '__main__':
    x = 2
    if True:
        x = 3
        print(x)

    print(x)




























